package meerkat.crypto.concrete.distributed_key_generation.Communication;

import com.google.protobuf.Message;
import meerkat.crypto.utilitis.Channel;
import meerkat.protobuf.DKGMessages;

/**
 * Created by Tzlil on 2/14/2016.
 */
public abstract class MailHandler implements Channel.ReceiverCallback{

    private MessageHandler messageHandler;
    public MailHandler(MessageHandler messageHandler){
        this.messageHandler = messageHandler;
    }

    public abstract Message extractMessage(DKGMessages.Mail mail);

    public void receiveMail(DKGMessages.Mail mail){

        Message message = extractMessage(mail);
        if (message == null)
            return;

        switch (mail.getType()) {
            case SHARE:
                messageHandler.handleSecretMessage(mail.getSender(), mail.getDestination() == ChannelImpl.BROADCAST
                        , message);
                break;
            case COMMITMENT:
                messageHandler.handleCommitmentMessage(mail.getSender(), mail.getDestination() == ChannelImpl.BROADCAST
                        , message);
                break;
            case DONE:
                messageHandler.handleDoneMessage(mail.getSender(), mail.getDestination() == ChannelImpl.BROADCAST
                        , message);
                break;
            case COMPLAINT:
                messageHandler.handleComplaintMessage(mail.getSender(), mail.getDestination() == ChannelImpl.BROADCAST
                        , message);
                break;
            case ANSWER:
                messageHandler.handleAnswerMessage(mail.getSender(), mail.getDestination() == ChannelImpl.BROADCAST
                        , message);
                break;
            case ABORT:
                messageHandler.handleAbortMessage(mail.getSender(), mail.getDestination() == ChannelImpl.BROADCAST
                        , message);
                break;
            default:
                break;
        }


    }
}
