package meerkat.crypto.concrete.distributed_key_generation.joint_feldman_protocol;

import meerkat.crypto.concrete.secret_shring.shamir.Polynomial;

import java.util.ArrayList;
import java.util.Arrays;

/**
 * Created by Tzlil on 3/14/2016.
 *
 * contains all relevant information on specific party during
 * the run of Joint Feldamn protocol
 */
// TODO: comments for every field.
public class Party<T> {
    public final int id;
    public Polynomial.Point share;
    public ArrayList<T> commitments;
    public boolean doneFlag;
    public DistributedKeyGeneration.ComplaintState[] complaints;
    public boolean aborted;

    public Party(int id, int n, int t) {
        this.id = id;
        this.share = null;
        this.doneFlag = false;
        this.complaints = new DistributedKeyGeneration.ComplaintState[n];
        Arrays.fill(this.complaints, DistributedKeyGeneration.ComplaintState.OK);
        this.commitments = new ArrayList<T>(t + 1);
        for (int i = 0; i <= t ; i++){
            commitments.add(null);
        }
        this.aborted = false;
    }
}
